diff -ruw gcc-6.5.0/isl-0.18/isl_test.c gcc-6.5.0-irix/isl-0.18/isl_test.c
--- gcc-6.5.0/isl-0.18/isl_test.c	Thu Dec 15 06:27:30 2016
+++ gcc-6.5.0-irix/isl-0.18/isl_test.c	Sun Dec 22 11:54:48 2024
@@ -493,19 +493,23 @@
 	return 0;
 }
 
-struct {
+struct vbo {
 	__isl_give isl_val *(*fn)(__isl_take isl_val *v1,
 				__isl_take isl_val *v2);
-} val_bin_op[] = {
-	['+'] = { &isl_val_add },
-	['-'] = { &isl_val_sub },
-	['*'] = { &isl_val_mul },
-	['/'] = { &isl_val_div },
-	['g'] = { &isl_val_gcd },
-	['m'] = { &isl_val_min },
-	['M'] = { &isl_val_max },
-};
+} vbo;
+struct vbo val_bin_op[256];
 
+void setup_val_bin_ops()
+{
+  val_bin_op['+'].fn=&isl_val_add;
+  val_bin_op['-'].fn=&isl_val_sub;
+  val_bin_op['*'].fn=&isl_val_mul;
+  val_bin_op['/'].fn=&isl_val_div;
+  val_bin_op['g'].fn=&isl_val_gcd;
+  val_bin_op['m'].fn=&isl_val_min;
+  val_bin_op['M'].fn=&isl_val_max;
+}
+
 struct {
 	const char *arg1;
 	unsigned char op;
@@ -4344,14 +4348,18 @@
 	return 0;
 }
 
-struct {
+struct abo {
 	__isl_give isl_aff *(*fn)(__isl_take isl_aff *aff1,
 				__isl_take isl_aff *aff2);
-} aff_bin_op[] = {
-	['+'] = { &isl_aff_add },
-	['-'] = { &isl_aff_sub },
-	['*'] = { &isl_aff_mul },
-	['/'] = { &isl_aff_div },
+} abo;
+struct abo aff_bin_op[256];
+
+void setup_aff_bin_ops()
+{
+  aff_bin_op['+'].fn=&isl_aff_add;
+  aff_bin_op['-'].fn=&isl_aff_sub;
+  aff_bin_op['*'].fn=&isl_aff_mul;
+  aff_bin_op['/'].fn=&isl_aff_div;
 };
 
 struct {
@@ -6943,6 +6951,9 @@
 	struct isl_ctx *ctx;
 	struct isl_options *options;
 
+	setup_val_bin_ops();
+	setup_aff_bin_ops();
+
 	options = isl_options_new_with_defaults();
 	assert(options);
 	argc = isl_options_parse(options, argc, argv, ISL_ARG_ALL);
Only in gcc-6.5.0-irix/isl-0.18: isl_test.c.orig
Only in gcc-6.5.0-irix/isl-0.18: isl_test.c.rej
Only in gcc-6.5.0-irix/isl-0.18: libisl.sgifixes.patch
diff -ruw gcc-6.5.0/libgcc/config.host gcc-6.5.0-irix/libgcc/config.host
--- gcc-6.5.0/libgcc/config.host	Tue Nov 21 04:41:34 2017
+++ gcc-6.5.0-irix/libgcc/config.host	Fri Jun 11 00:13:30 2021
@@ -141,6 +141,15 @@
 microblaze*-*-*)
 	cpu_type=microblaze
 	;;
+mips-sgi-irix6.5*)
+	# Use the historical IRIX mips FP configs
+	cpu_type=mips
+	tmake_file="mips/t-mips-irixfp"
+	# This doesn't work yet.
+	if test "${host_address}" = 64; then
+		tmake_file="${tmake_file} mips/t-mips-irixfp64"
+	fi
+	;;
 mips*-*-*)
 	# All MIPS targets provide a full set of FP routines.
 	cpu_type=mips
@@ -853,6 +862,11 @@
 	tmake_file="${tmake_file} microblaze/t-microblaze t-fdpbit"
 	extra_parts="$extra_parts crtbeginS.o crtendS.o crtbeginT.o crti.o crtn.o"
 	;;
+mips-sgi-irix6.5*)
+	tmake_file="$tmake_file mips/t-irix6 t-crtfm mips/t-tpbit t-slibgcc mips/t-slibgcc-irix"
+	extra_parts="crtbegin.o crtend.o crtfastmath.o irix-crti.o irix-crtn.o"
+	md_unwind_header=mips/irix6-unwind.h
+	;;
 microblaze*-*-rtems*)
 	tmake_file="${tmake_file} microblaze/t-microblaze t-fdpbit"
 	extra_parts="$extra_parts crtbeginS.o crtendS.o crtbeginT.o crti.o crtn.o"
diff -ruw gcc-6.5.0/libgcc/config/mips/sfp-machine.h gcc-6.5.0-irix/libgcc/config/mips/sfp-machine.h
--- gcc-6.5.0/libgcc/config/mips/sfp-machine.h	Mon Jan  4 09:30:50 2016
+++ gcc-6.5.0-irix/libgcc/config/mips/sfp-machine.h	Fri Jun 11 00:13:30 2021
@@ -22,6 +22,8 @@
 see the files COPYING3 and COPYING.RUNTIME respectively.  If not, see
 <http://www.gnu.org/licenses/>.  */
 
+#if !defined(__sgi)
+
 #ifdef __mips64
 #define _FP_W_TYPE_SIZE		64
 #define _FP_W_TYPE		unsigned long long
@@ -178,3 +180,5 @@
 # define strong_alias(name, aliasname) _strong_alias(name, aliasname)
 # define _strong_alias(name, aliasname) \
   extern __typeof (name) aliasname __attribute__ ((alias (#name)));
+
+#endif /* !defined(__sgi) */
Only in gcc-6.5.0-irix/libgcc/config/mips: t-irix6
Only in gcc-6.5.0-irix/libgcc/config/mips: t-mips-irixfp
Only in gcc-6.5.0-irix/libgcc/config/mips: t-slibgcc-irix
diff -ruw gcc-6.5.0/libgomp/configure.tgt gcc-6.5.0-irix/libgomp/configure.tgt
--- gcc-6.5.0/libgomp/configure.tgt	Thu Sep  3 12:20:35 2015
+++ gcc-6.5.0-irix/libgomp/configure.tgt	Fri Jun 11 00:13:30 2021
@@ -145,6 +145,11 @@
 	XLDFLAGS="${XLDFLAGS} -lpthread"
 	;;
 
+  mips-sgi-irix*)
+	# Need to link with -lpthread so libgomp.so is self-contained.
+	XLDFLAGS="${XLDFLAGS} -lpthread"
+	;;
+
   *-*-aix*)
 	config_path="posix"
 	# Need to link with -lpthread so libgomp.so is self-contained.
diff -ruw gcc-6.5.0/libgomp/env.c gcc-6.5.0-irix/libgomp/env.c
--- gcc-6.5.0/libgomp/env.c	Fri May  5 17:47:20 2017
+++ gcc-6.5.0-irix/libgomp/env.c	Sun Dec 22 13:34:47 2024
@@ -1166,6 +1166,10 @@
     {
       fputs ("  GOMP_CPU_AFFINITY = ''\n", stderr);
       fprintf (stderr, "  GOMP_STACKSIZE = '%lu'\n", stacksize);
+#if defined(__sgi)
+      fprintf (stderr, "  GOMP_SPINCOUNT = '%lu'\n",
+               (unsigned long) gomp_spin_count_var);
+#else
 #ifdef HAVE_INTTYPES_H
       fprintf (stderr, "  GOMP_SPINCOUNT = '%"PRIu64"'\n",
 	       (uint64_t) gomp_spin_count_var);
@@ -1173,6 +1177,7 @@
       fprintf (stderr, "  GOMP_SPINCOUNT = '%lu'\n",
 	       (unsigned long) gomp_spin_count_var);
 #endif
+#endif
     }
 
   fputs ("OPENMP DISPLAY ENVIRONMENT END\n", stderr);
diff -ruw gcc-6.5.0/libgomp/oacc-parallel.c gcc-6.5.0-irix/libgomp/oacc-parallel.c
--- gcc-6.5.0/libgomp/oacc-parallel.c	Thu Mar 17 11:07:54 2016
+++ gcc-6.5.0-irix/libgomp/oacc-parallel.c	Sun Dec 22 13:37:03 2024
@@ -75,7 +75,10 @@
   int async = GOMP_ASYNC_SYNC;
   unsigned dims[GOMP_DIM_MAX];
   unsigned tag;
-
+#if defined(__sgi)
+  gomp_debug (0, "%s: mapnum=%lu, hostaddrs=%p, sizes=%p, kinds=%p\n",
+              __FUNCTION__, (unsigned long) mapnum, hostaddrs, sizes, kinds);
+#else 
 #ifdef HAVE_INTTYPES_H
   gomp_debug (0, "%s: mapnum=%"PRIu64", hostaddrs=%p, size=%p, kinds=%p\n",
 	      __FUNCTION__, (uint64_t) mapnum, hostaddrs, sizes, kinds);
@@ -83,6 +86,7 @@
   gomp_debug (0, "%s: mapnum=%lu, hostaddrs=%p, sizes=%p, kinds=%p\n",
 	      __FUNCTION__, (unsigned long) mapnum, hostaddrs, sizes, kinds);
 #endif
+#endif
   goacc_lazy_initialize ();
 
   thr = goacc_thread ();
@@ -214,7 +218,10 @@
 {
   bool host_fallback = device == GOMP_DEVICE_HOST_FALLBACK;
   struct target_mem_desc *tgt;
-
+#if defined(__sgi)
+  gomp_debug (0, "%s: mapnum=%lu, hostaddrs=%p, sizes=%p, kinds=%p\n",
+              __FUNCTION__, (unsigned long) mapnum, hostaddrs, sizes, kinds);
+#else
 #ifdef HAVE_INTTYPES_H
   gomp_debug (0, "%s: mapnum=%"PRIu64", hostaddrs=%p, size=%p, kinds=%p\n",
 	      __FUNCTION__, (uint64_t) mapnum, hostaddrs, sizes, kinds);
@@ -222,6 +229,7 @@
   gomp_debug (0, "%s: mapnum=%lu, hostaddrs=%p, sizes=%p, kinds=%p\n",
 	      __FUNCTION__, (unsigned long) mapnum, hostaddrs, sizes, kinds);
 #endif
+#endif
 
   goacc_lazy_initialize ();
 
diff -ruw gcc-6.5.0/libgomp/target.c gcc-6.5.0-irix/libgomp/target.c
--- gcc-6.5.0/libgomp/target.c	Tue Apr 12 03:05:29 2016
+++ gcc-6.5.0-irix/libgomp/target.c	Sun Dec 22 13:27:42 2024
@@ -734,6 +734,11 @@
 			 was missing.  */
 		      size_t size = k->host_end - k->host_start;
 		      gomp_mutex_unlock (&devicep->lock);
+#if defined(__sgi)
+                      gomp_fatal ("present clause: !acc_is_present (%p, "
+                                  "%lu (0x%lx))", (void *) k->host_start,
+                                  (unsigned long) size, (unsigned long) size);
+#else
 #ifdef HAVE_INTTYPES_H
 		      gomp_fatal ("present clause: !acc_is_present (%p, "
 				  "%"PRIu64" (0x%"PRIx64"))",
@@ -744,6 +749,7 @@
 				  "%lu (0x%lx))", (void *) k->host_start,
 				  (unsigned long) size, (unsigned long) size);
 #endif
+#endif
 		    }
 		    break;
 		  case GOMP_MAP_FORCE_DEVICEPTR:
diff -ruw gcc-6.5.0/libgomp/config/posix/proc.c gcc-6.5.0-irix/libgomp/config/posix/proc.c
--- gcc-6.5.0/libgomp/config/posix/proc.c	Mon Jan  4 09:30:50 2016
+++ gcc-6.5.0-irix/libgomp/config/posix/proc.c	Fri Jun 11 00:19:05 2021
@@ -38,6 +38,9 @@
 # endif
 #endif
 
+#ifdef __sgi
+ #define _SC_NPROCESSORS_ONLN _SC_NPROC_ONLN
+#endif
 
 /* At startup, determine the default number of threads.  It would seem
    this should be related to the number of cpus online.  */
diff -ruw gcc-6.5.0/libstdc++-v3/acinclude.m4 gcc-6.5.0-irix/libstdc++-v3/acinclude.m4
--- gcc-6.5.0/libstdc++-v3/acinclude.m4	Fri May 26 08:01:06 2017
+++ gcc-6.5.0-irix/libstdc++-v3/acinclude.m4	Fri Jun 11 00:14:45 2021
@@ -316,7 +316,7 @@
     AC_MSG_CHECKING([for ld that supports -Wl,-z,relro])
     cxx_z_relo=`$LD -v --help 2>/dev/null | grep "z relro"`
     if test -n "$cxx_z_relo"; then
-      OPT_LDFLAGS="-Wl,-z,relro"
+      OPT_LDFLAGS="-Wl,-z,relro $OPT_LDFLAGS"
       ac_ld_relro=yes
     fi
     AC_MSG_RESULT($ac_ld_relro)
diff -ruw gcc-6.5.0/libstdc++-v3/configure.host gcc-6.5.0-irix/libstdc++-v3/configure.host
--- gcc-6.5.0/libstdc++-v3/configure.host	Tue Sep 27 02:11:15 2016
+++ gcc-6.5.0-irix/libstdc++-v3/configure.host	Fri Jun 11 00:13:30 2021
@@ -277,6 +277,15 @@
   hpux*)
     os_include_dir="os/hpux"
     ;;
+  irix6.5*)
+    os_include_dir="os/irix/irix6.5"
+    atomicity_dir=os/irix
+    atomic_word_dir=os/irix
+    # libstdc++.so relies on emutls on IRIX, which only works with the
+    # real functions implemented in libpthread.so, not with the stubs in
+    # libc, so always pass -lpthread.
+    OPT_LDFLAGS="${OPT_LDFLAGS} -lpthread"
+    ;;
   mingw32*)
     case "$host" in
       *-w64-*)
Only in gcc-6.5.0-irix/libstdc++-v3/config/os: irix
